//
// PointsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class PointsAPI {
    /**
     NWS advisories, watches and warnings for a Latitude/Longitude point.

     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func pointsLatitudelongitudeGet(latitude: Float, longitude: Float, completion: @escaping ((_ data: NwsWarningsPointObj?,_ error: Error?) -> Void)) {
        pointsLatitudelongitudeGetWithRequestBuilder(latitude: latitude, longitude: longitude).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     NWS advisories, watches and warnings for a Latitude/Longitude point.
     - GET /points/{latitude},{longitude}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "warnings" : [ {
    "phenomCode" : "WI",
    "significance" : "WATCH",
    "timestampExpires" : "2019-12-20T23:00:00-05:00",
    "phenomDesc" : "Wind"
  }, {
    "phenomCode" : "WI",
    "significance" : "WATCH",
    "timestampExpires" : "2019-12-20T23:00:00-05:00",
    "phenomDesc" : "Wind"
  } ],
  "location" : {
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "fieldList" : {
    "fields" : {
      "timestampExpires" : "Timestamp as string: RFC 3339",
      "phenomCode" : "String value",
      "phenomDesc" : "String value",
      "significance" : "String value in"
    }
  }
}}]
     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 

     - returns: RequestBuilder<NwsWarningsPointObj> 
     */
    open class func pointsLatitudelongitudeGetWithRequestBuilder(latitude: Float, longitude: Float) -> RequestBuilder<NwsWarningsPointObj> {
        var path = "/points/{latitude},{longitude}"
        let latitudePreEscape = "\(latitude)"
        let latitudePostEscape = latitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{latitude}", with: latitudePostEscape, options: .literal, range: nil)
        let longitudePreEscape = "\(longitude)"
        let longitudePostEscape = longitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{longitude}", with: longitudePostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<NwsWarningsPointObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
}
